/*	$Id: main.c,v 1.48 2015/06/03 09:02:37 kristaps Exp $ */
/*
 * Copyright (c) 2014, 2015 Kristaps Dzonsons <kristaps@kcons.eu>
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#ifdef __APPLE__
#include <GLUT/glut.h>
#else
#include <GL/glut.h>
#endif
#include <gd.h>
#include <gsl/gsl_rng.h>
#include <SDL_mixer.h>
#include <flocks.h>

#include "extern.h"

int
main(int argc, char *argv[])
{
	int	 	 c, rc;
	char		*cfg[CFGKEY__MAX],
			*fecfg[FECFGKEY__MAX];
	const char	*progname;

	if (NULL == (progname = strrchr(argv[0], '/')))
		progname = argv[0];
	else
		++progname;

	memset(cfg, 0, CFGKEY__MAX * sizeof(char *));
	memset(fecfg, 0, FECFGKEY__MAX * sizeof(char *));

	while (-1 != (c = getopt(argc, argv, "M:O:")))
		switch (c) {
		case ('M'):
			rc = cfg_parsekey
				(optarg, fecfg, FECFGKEY__MAX,
				 (const char *const *)fecfgkeys);
			if ( ! rc)
				goto usage;
			break;
		case ('O'):
			rc = cfg_parsekey
				(optarg, cfg, CFGKEY__MAX, 
				 (const char *const *)cfgkeys);
			if ( ! rc)
				goto usage;
			break;
		default:
			goto usage;
		}

	return(mainGL(argc, argv, fecfg, cfg));
usage:
	/* FIXME */
	fprintf(stderr, "usage: %s ...\n", progname);
	return(EXIT_FAILURE);
}
